package dev.pfaff.altargui.util;

import java.util.concurrent.locks.ReentrantReadWriteLock;

public final class Gate {
	private final ReentrantReadWriteLock lock = new ReentrantReadWriteLock();

	public void lock() {
		this.lock.writeLock().lock();
	}

	public void unlock() {
		this.lock.writeLock().unlock();
	}

	public void await() throws InterruptedException {
		if (this.lock.isWriteLocked()) { // slow path
			this.lock.readLock().lockInterruptibly();
			this.lock.readLock().unlock();
		}
	}

	public void awaitUninterruptibly() {
		if (this.lock.isWriteLocked()) { // slow path
			this.lock.readLock().lock();
			this.lock.readLock().unlock();
		}
	}
}
